#ifndef MATERIAL_H
#define MATERIAL_H

class Shader;

struct Material
{
    /**
     * @brief bindAttributes should send the material attribute to the specified shader as a uniform
     * if the shader is NULL, we can assume that modern opengl is not available and try to apply the material differently (glMaterial)
     */
    virtual void bindAttributes(Shader*) = 0;

    /**
     * @brief getFlags should return flags beginning with MATERIAL from the enum available in mesh.h
     */
    virtual unsigned int getFlags() = 0;

    virtual ~Material() {}
};

#endif // MATERIAL_H
