#ifndef SPARROWRENDERER_H
#define SPARROWRENDERER_H

#include "glew.h"
#include <vector>
#include <string>
#include <glm/vec3.hpp>

class Camera;
class Module;
class Scene;
class Pipeline;

class SparrowRenderer
{
public:
    SparrowRenderer() :
        m_scene(NULL)
    {}

    // main methods
    void initGL(int w, int h, bool forceCrappy = false);
    void resizeGL(int w, int h);
	void renderGL();

    static bool isModernOpenGLAvailable();

    // scene methods
    void setScene(Scene* myScene);

protected:
    int width;
    int height;

    Scene* m_scene;

    static bool modernOpenglAvailable;
};

#endif // SPARROWRENDERER_H
